using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PhysicsCheck : MonoBehaviour
{
    private CapsuleCollider2D coll;

    [Header("")]
    public bool manual;//ֶ

    public Vector2 bottomOffest;//ƫ
    public Vector2 leftOffest;
    public Vector2 rightOffest;

    public float checkRaduis;

    public LayerMask groundLayer;

    [Header("״̬")]
    public bool isGround;
    public bool touchLeftWall;//Ӵǽ
    public bool touchRightWall;


    private void Awake()
    {
        coll = GetComponent<CapsuleCollider2D>();

        if (!manual)//ֶĬϱֵ߽
        {
            rightOffest = new Vector2((coll.bounds.size.x+ coll.offset.x) / 2, coll.bounds.size.y / 2);
            leftOffest = new Vector2(-rightOffest.x, rightOffest.y);
        }
    }

    private void Update()
    {
        Check();
    }

    public void Check()
    {
        //
        isGround = Physics2D.OverlapCircle((Vector2)transform.position+bottomOffest, checkRaduis, groundLayer);

        //ǽ
        touchLeftWall = Physics2D.OverlapCircle((Vector2)transform.position + leftOffest, checkRaduis, groundLayer);
        touchRightWall = Physics2D.OverlapCircle((Vector2)transform.position + rightOffest, checkRaduis, groundLayer);
    }

    private void OnDrawGizmosSelected()
    {
        Gizmos.DrawWireSphere((Vector2)transform.position + bottomOffest, checkRaduis);
        Gizmos.DrawWireSphere((Vector2)transform.position + leftOffest, checkRaduis);
        Gizmos.DrawWireSphere((Vector2)transform.position + rightOffest, checkRaduis);
    }

}
